/****************************************************************************

 PROGRAM: sqcpswin.c


 ****************************************************************************/

#include "windows.h"
#include "sqcpswin.h"
#include "sqcps.h"
#include <string.h>
#include <stdlib.h>
#include <ctype.h>


HANDLE hInst;

HWND hMainWnd;                    /* handle to main windows  */ 

HWND hDialog;
HWND hCombo;

HWND hDataLenWnd;
HWND hDataWnd;
HWND hPassWnd;

HANDLE hHourGlass;                        /* handle to hourglass cursor      */

HACCEL hAccTable;

char init_msg_hdr[] = "Init SQ-CPS diskette";
char check_msg_hdr[] = "Check SQ-CPS diskette";

char * init_err_msg[] =
{
    "SQ-CPS diskette initialized",
    "invalid drive",
    "drive not ready",
    "diskette error",
    "no SQ-CPS diskette found",
    "SQ-CPS diskette is write protected"
};

char * check_err_msg[] =
{
    "SQ-CPS diskette found",
    "invalid drive",
    "drive not ready",
    "diskette error",
    "no SQ-CPS diskette found"
};

int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
    MSG msg;

    if (!hPrevInstance)
	if (!InitApplication(hInstance))
	    return (FALSE);

    if(!InitInstance(hInstance, nCmdShow))
	return (FALSE);

    while (GetMessage(&msg, NULL, NULL, NULL))
    {
	if (IsDialogMessage (hDialog, &msg))
	{
	    continue;
	}

	TranslateMessage(&msg);
	DispatchMessage(&msg); 
    }
    return (msg.wParam);
}



BOOL InitApplication(hInstance)
HANDLE hInstance;
{
    WNDCLASS  wc;

    wc.style = NULL;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  "sqcpswinMenu";
    wc.lpszClassName = "sqcpswinWClass";

    return (RegisterClass(&wc));
}



BOOL InitInstance(hInstance, nCmdShow)
HANDLE          hInstance;
int             nCmdShow;
{
    LRESULT dw_index;

    hInst = hInstance;

    hMainWnd = CreateWindow("sqcpswinWClass",
			    "SQ-CPS Init/Check Diskette",
			    WS_OVERLAPPEDWINDOW,
			    0, 0,
			    400, 300,
			    NULL, NULL, hInstance, NULL);

    if (!hMainWnd)
	return (FALSE);


    hHourGlass = LoadCursor(NULL, IDC_WAIT);

    ShowWindow(hMainWnd, nCmdShow);
    UpdateWindow(hMainWnd);

    hDialog = CreateDialog(hInst,
			   (LPCSTR) "main_window",
			   hMainWnd,
			   DialogWndProc);

    hDataWnd = GetDlgItem (hDialog, (int) IDC_EDIT_DATA);
    hDataLenWnd = GetDlgItem (hDialog, (int) IDC_EDIT_DATA_SIZE);
    hPassWnd = GetDlgItem (hDialog, (int) IDC_EDIT_PASSWD);
    dw_index = SendMessage (hDataLenWnd,
			    (UINT) WM_SETTEXT,
			    (WPARAM) (UINT) 0,
			    (LPARAM) ((LPSTR) "0"));

    hCombo = GetDlgItem (hDialog, (int) IDC_DRIVES);
    SendMessage (hCombo, 
		 (UINT) CB_LIMITTEXT,
		 (WPARAM) (UINT) 8,
		 (LPARAM) 0);
    dw_index = SendMessage (hCombo, 
			    (UINT) CB_DIR,
			    (WPARAM) (UINT) (DDL_DRIVES | DDL_EXCLUSIVE),
			    (LPARAM) ((LPSTR) "*"));
    SendMessage (hCombo, 
		 (UINT) CB_SETCURSEL,
		 (WPARAM) (UINT) 0,
		 (LPARAM) 0);

    return (TRUE);

}


long FAR PASCAL __export MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{

    switch (message)
    {
    case WM_COMMAND:
	{
	    switch (wParam)
	    {	    
	    case IDM_EXIT:
	    case IDCANCEL:
		DestroyWindow(hDialog);
		hDialog = NULL;
		DestroyWindow(hWnd);
		return (NULL);

	    default:
		return (DefWindowProc(hWnd, message, wParam, lParam));
	    }
	    break; 
	}

    case WM_DESTROY:
	if (hDialog)
	{
	    DestroyWindow(hDialog);
	}    
	PostQuitMessage(0);
	break;

    default:
	return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}

BOOL __export CALLBACK DialogWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{
    switch (message)
    {
    case WM_INITDIALOG:
	{
	    RECT WinRect, ClientRect, DialogRect;
	    int win_x_size, win_y_size;
	    int client_x_size, client_y_size;
	    int dialog_x_size, dialog_y_size;
	    int x_border, y_border;

	    hDialog = hWnd; 
	    GetWindowRect(hDialog, (LPRECT) &DialogRect);
	    GetWindowRect(hMainWnd, (LPRECT) &WinRect);
	    GetClientRect(hMainWnd, (LPRECT) &ClientRect);

	    win_x_size = WinRect.right - WinRect.left;
	    win_y_size = WinRect.bottom - WinRect.top;
	    client_x_size = ClientRect.right - ClientRect.left;
	    client_y_size = ClientRect.bottom - ClientRect.top;
	    x_border = win_x_size - client_x_size;
	    y_border = win_y_size - client_y_size;
	    dialog_x_size = DialogRect.right - DialogRect.left;
	    dialog_y_size = DialogRect.bottom - DialogRect.top;

	    if (   (ClientRect.right > dialog_x_size)
		|| (ClientRect.bottom > dialog_y_size))
	    {
		if (ClientRect.right > dialog_x_size)
		{
		    ClientRect.right = dialog_x_size;
		}
		if (ClientRect.bottom > dialog_y_size)
		{
		    ClientRect.bottom = dialog_y_size;
		}
		client_x_size = ClientRect.right - ClientRect.left;
		client_y_size = ClientRect.bottom - ClientRect.top;
		win_x_size = client_x_size + x_border;
		win_y_size = client_y_size + y_border;

		SetWindowPos (hMainWnd, HWND_TOP,
			      WinRect.left, WinRect.top,
			      (win_x_size), (win_y_size),
			      SWP_NOZORDER);
	    } 

	    return (TRUE);
	}

    case WM_COMMAND:
	{
	    short sqcps_rc = -1;
	    int user_data_len;
	    unsigned char user_data[128];
	    unsigned char passwd[128];
	    unsigned char drive[24];
	    unsigned char * drive_ptr;
	    WORD text_len;
	    LPCSTR msg_hdr;
	    LPCSTR __far * err_msg;
	    HANDLE hSaveCursor;		/* current cursor handle      */

	    switch (wParam)
	    {

	    case IDC_CHECK:
		hSaveCursor = SetCursor(hHourGlass);

		msg_hdr = (LPCSTR) check_msg_hdr;
		err_msg = (LPCSTR *) check_err_msg;

		text_len = (WORD) SendMessage (hDataLenWnd, WM_GETTEXT, 120,
					       (DWORD) (LPSTR) user_data); 
		user_data[text_len] = '\0';
		user_data_len = atoi (user_data);

		text_len = (WORD) SendMessage (hPassWnd, WM_GETTEXT, 120,
					       (DWORD) (LPSTR) passwd); 
		passwd[text_len] = '\0';

		text_len = (WORD) SendMessage (hCombo, WM_GETTEXT, 20,
					       (DWORD) (LPSTR) drive); 
		drive[text_len] = '\0';
		drive_ptr = drive;
		for (;drive_ptr[0];drive_ptr++)
		{
		    if (isalpha (drive_ptr[0]))
		    {
			drive[0] = drive_ptr[0];
			drive[1] = ':';
			drive[2] = '\0';
			break;
		    }
		}

		sqcps_rc = sqcpsrd (drive,
				    user_data, user_data_len,
				    passwd);
		if (!(sqcps_rc))
		{
		    user_data[user_data_len] = '\0';
		    SendMessage (hDataWnd, WM_SETTEXT, user_data_len,
				 (DWORD) (LPSTR) user_data); 
		}
		SetCursor(hSaveCursor);            /* restore the cursor */
		break;

	    case IDC_INIT:
		hSaveCursor = SetCursor(hHourGlass);

		msg_hdr = (LPCSTR) init_msg_hdr;
		err_msg = (LPCSTR __far *) init_err_msg;
		text_len = (WORD) SendMessage (hDataWnd, WM_GETTEXT, 120,
					       (DWORD) (LPSTR) user_data); 
		user_data[text_len] = '\0';
		user_data_len = strlen (user_data);

		text_len = (WORD) SendMessage (hPassWnd, WM_GETTEXT, 120,
					       (DWORD) (LPSTR) passwd); 
		passwd[text_len] = '\0';

		text_len = (WORD) SendMessage (hCombo, WM_GETTEXT, 20,
					       (DWORD) (LPSTR) drive); 
		drive[text_len] = '\0';
		drive_ptr = drive;
		for (;drive_ptr[0];drive_ptr++)
		{
		    if (isalpha (drive_ptr[0]))
		    {
			drive[0] = drive_ptr[0];
			drive[1] = ':';
			drive[2] = '\0';
			break;
		    }
		}

		sqcps_rc = sqcpswr (drive,
				    user_data, user_data_len,
				    passwd);
		SetCursor(hSaveCursor);            /* restore the cursor */
		break;

	    case IDM_EXIT:
		SendMessage (hMainWnd,
			     WM_COMMAND,
			     (WPARAM) (UINT) IDCANCEL,
			     (LPARAM) 0);
		return (FALSE);

	    default:
		return (FALSE);

	    } 
	    if (   (sqcps_rc >= 0)
		&& (sqcps_rc <= 5))
	    {
		MessageBox (GetFocus(),
			    err_msg[sqcps_rc],
			    msg_hdr,
			    MB_ICONASTERISK | MB_OK);
#ifdef xxx
		CheckDlgButton (hDialog, wParam, 1);
#endif
	    }        
	}

	break;

    case WM_DESTROY:
	break;

    default:
	break;
    }
    return (NULL);
}


